var db = require('dynamodb-wrap');
var async = require('async');
var common = require('require-dir')('../common');
var helper = require('require-dir')('./helper');
var fulfillment = require('require-dir')('../fulfillment');

module.exports = createAlert;

function createAlert(input, mainCallback) {
    async.parallel([

            function(callback) {
                fulfillment.getSubscription(input.customerId, input.env, callback);
            },
            function(callback) {
                common.alertQueues(input.env, callback);
            },
            function(callback) {
                helper.determineAlertCategory(input.alertType, callback);
            }
        ],
        function(err, results) {
            if(err) {
                return mainCallback(err);
            }
            results.push(input.customerId);
            results.push(input.alertType);
            helper.alertBuilder(results, function(err, message){
                if(err){
                    return mainCallback(err, message);
                }

                var params = {
                    message: JSON.stringify(message),
                    url: results[1]
                };

                common.sqs(params, mainCallback);
            });
        });
}

