var template = require('require-dir')('./template');
var uuid = require('node-uuid');

module.exports = alertBuilder;

function alertBuilder(data, callback) {
    var response = null;
    if (data[2] === 'credit') {
        response = creditAlertBuilder(data);
    } else if (data[2] === 'score') {
        response = scoreAlertBuilder(data);
    } else {
        return callback('invalid category');
    }
    return callback(null, response);
}

function creditAlertBuilder(data) {
    var response = template.credit;
    response.subscriptionId = data[0];
    response.customerId = data[3];
    var alertData = JSON.parse(response.data.alert);
    alertData.alertType = data[4];
    response.data.alert = JSON.stringify(alertData);
    response.eventId = uuid.v4();
    response.correlationId = uuid.v4();
    response.timestamp = new Date().toISOString();
    return response;
}

function scoreAlertBuilder(data) {
    var response = template.score;
    response.data.subscriptionId = data[0];
    response.eventId = uuid.v4();
    response.correlationId = uuid.v4();
    response.timestamp = new Date().toISOString();
    response.customerId = data[3];
    scoreAlertDataBuilder(response, data[4]);
    return response;
}

function scoreAlertDataBuilder(message, type) {
    if (type === 'SCORED') {
        message.data.previousScore = '630';
        message.data.newScore = '610';
        message.data.previousRating= 'good';
        message.data.newRating= 'good';
    } else if (type === 'SCOREI') {
        message.data.previousScore = '610';
        message.data.newScore = '630';
        message.data.previousRating= 'good';
        message.data.newRating= 'good';
    } else if (type === 'SCORERI') {
        message.data.previousScore = '610';
        message.data.newScore = '630';
        message.data.previousRating= 'good';
        message.data.newRating= 'exceptional';
    } else if (type === 'SCORERD') {
        message.data.previousScore = '630';
        message.data.newScore = '610';
        message.data.previousRating= 'exceptional';
        message.data.newRating= 'good';
    }
}
