var express = require('express');
var debug = require('debug')('main');
var router = express.Router();

var alerts = require('require-dir')('./alerts');

router.post('/create', function(req, res, next) {
    if(!req.body.customerid || !req.body.env || !req.body.alerttype){
        res.status(406).json({code: 'missing params'});
        return;
    }

    var output = {
        customerId: req.body.customerid,
        env: req.body.env,
        alertType: req.body.alerttype
    };

    alerts.createAlert(output, function(err, results) {
        if (err) {
            res.status(405).json(err);
        } else {
            res.json(results);
        }
    });
});

router.get('/list', function(req, res, next) {
    alerts.getAlertList(function(err, results) {
        if (err) {
            res.status(405).json(err);
        } else {
            res.json(results);
        }
    });
});

router.get('/creditlist', function(req, res, next) {
    alerts.getCreditList(function(err, results) {
        if (err) {
            res.status(405).json(err);
        } else {
            res.json(results);
        }
    });
});

module.exports = router;
