var db = require('dynamodb-wrap');

module.exports = getTable;

var tables = {
    'dev': 'network-develop-ConfigTable-1FBHVY0VKB5JA',
    'int': 'network-integration-ConfigTable-AGN1HY42DAYZ'
};

function getTable(env, callback) {
    db.scan({
        table: tables[env]
    }, function(err, data) {
        if (err) {
            callback(err);
        }
        extractFulfillmentTable(data, callback);
    });
}

function extractFulfillmentTable(data, callback) {
    var response;
    var obj;
    try {
        data.forEach(function(val) {
            if (val.version === '0.9' && val.service === 'fulfillment') {
                obj = JSON.parse(val.config);
                obj.dynamo_tables.forEach(function(inner) {
                    if (inner.logicalid === 'Subscription') {
                        if (inner.physicalid.length > 0) {
                            response = inner.physicalid[0];
                        }
                    }
                });

            }
        });
    }
    catch(err){
        return callback('fulfillment table not found');
    }
    if(!response){
        callback('fulfillment table not found');
    }
    else {
        callback(null, response);
    }
}
