var db = require('dynamodb-wrap');
var common = require('require-dir')('../common');

module.exports = getSubscriptionId;

function getSubscriptionId(customerId, env, callback) {
    common.fulfillmentTables(env, function(err, table) {
        if (err || !table) {
            return callback('Table not found');
        }

        var params = {
            table: table,
            key: {
                customerId: {
                    ComparisonOperator: 'EQ',
                    AttributeValueList: [{
                        S: customerId
                    }]
                }
            }
        };
        db.query(params, function(err, results) {
            if (results && results.length === 0) {
                err = 'Customer not found';
            }
            if (err) {
                return callback(err, null);
            } else {
                return callback(null, results[0].subscriptionId);
            }
        });
    });
}
