var app = angular.module('main');

app.controller('homeCtrl', homeCtrl);
homeCtrl.$inject = ['$timeout', '$scope', '$q', '$location', 'alertRepo'];

function homeCtrl($timeout, $scope, $q, $location, alertRepo) {

    $scope.init = function() {
        $scope.alertType = [];
        $scope.selectedAlertType = '';
        $scope.domain = 'dev';
        $scope.customerId = '';
        $scope.createAlert = createAlert;
        loadOptions();
    };

    function createAlert() {
        NProgress.inc();
        var params = {
            env: $scope.domain,
            customerid: $scope.customerId,
            alerttype: $scope.selectedAlertType
        };

        alertRepo.create(params).then(
            function(data) {
                NProgress.done();
                bootbox.alert('Alert created successfully!');
            },
            function(err) {
                NProgress.done();
                bootbox.alert('Alert creation error: ' + JSON.stringify(err));
            });
    }

    function loadOptions() {
        NProgress.inc();
        alertRepo.listAlerts().then(
            function(data) {
                $scope.alertType = data.sort();
                $scope.selectedAlertType = data[0];
                NProgress.done();
            },
            function(err) {
                NProgress.done();
            });
    }


}
