(function() {

    'use strict';

    angular.module('main').factory('alertRepo', alertRepo);
    alertRepo.$inject = ['abstractRepo', '$http', '$q'];

    function alertRepo(abstractRepo, $http, $q) {

        // Define the functions and properties to reveal.
        return {
            listAlerts: listAlerts,
            create: create
        };

        function listAlerts() {
                var settings = {
                    url: '/api/alerts/list',
                    cache: true
                };
                return abstractRepo.apiCall(settings);
        }

        function create(data) {
            var settings = {
                url: '/api/alerts/create',
                method: 'POST',
                data: data
            };
            return abstractRepo.apiCall(settings);
        }
    }

})();
